% PicoScope units setting area !!!
% clc
% load PicoMatlab library
if not(libisloaded('ps4000'))
    loadlibrary('ps4000','ps4000Api.h')
end
if not(libisloaded('ps4000wrap'))
    loadlibrary('ps4000wrap','ps4000wrap.h')
end
%%
% Enumerate PicoScope units
Count = int16(100);
Count_ptr = libpointer('int16Ptr',Count);
Serials = char(uint16(zeros(128,1)));
Serials_ptr = libpointer('voidPtr',uint16(Serials));
SerialLth = int16(128);
SerialLth_ptr = libpointer('int16Ptr',SerialLth);
[Status Count Serials SerialLth] = calllib('ps4000','ps4000EnumerateUnits',Count,Serials,SerialLth);
disp(num2str(Count));
disp(char(Serials));
clear('Count_ptr','SerialLth_ptr')

Serial = {'ZOR15/026'};
Serial{2} = 'ZOR15/065';
Serial{3} = 'ZOR15/051';

%%
pause(3)
for k = 1:Count
    UnitHandleTemp = int16(0);
    UnitHandle_ptr(k) = libpointer('int16Ptr',UnitHandleTemp);
    [Status UnitHandleTemp] = calllib('ps4000','ps4000OpenUnit',UnitHandleTemp);
    disp(strcat('OpenUnit=',num2str(Status)))
    
%%
    String = char(uint16(ones(1,127)));
    String_ptr = libpointer('voidPtr',[uint16(String) 0]);
    StringLength = int16(128);
    RequiredSize = int16(128);
    RequiredSize_Ptr(k) = libpointer('int16Ptr',RequiredSize);
    InfoCode = uint32(4);
    [Status String] = calllib('ps4000','ps4000GetUnitInfo',UnitHandleTemp,String,StringLength,RequiredSize_Ptr(k),InfoCode);

disp(strcat('GetUnitInfo=',num2str(Status)));
% get(String_ptr,'value')
disp(String)
    disp(strcat('PicoSerial=',String))
    switch String
        case Serial{1}
            UnitHandle(1) = UnitHandleTemp;
            disp('PicoScope 1 is found')
        case Serial{2}
            UnitHandle(2) = UnitHandleTemp;
            disp('PicoScope 2 is found')
        case Serial{3}
            UnitHandle(3) = UnitHandleTemp;
            disp('PicoScope 3 is found')
    end
    pause(3)
end